﻿Imports System.IO
Imports System.ComponentModel
Imports System.Collections.Generic

Public Class Envelop

    Const ST_MAIL_COUNT As Integer = 0, ST_MAILTO As Integer = 1, ST_MAILTO_CSV_FILE As Integer = 2
    Const ST_BODY_FILE As Integer = 3, ST_ATTACH_FILE As Integer = 4, ST_SUBJECT As Integer = 5
    Const ST_MAILFROM As Integer = 6, ST_MAIL_CC As Integer = 7, ST_MAIL_BCC As Integer = 8
    Const ST_MAIL_HEADER As Integer = 9, ST_SERVER As Integer = 10, ST_PLAN_DATETIME As Integer = 11
    Const ST_START_DATETIME As Integer = 12, ST_END_DATETIME As Integer = 13, ST_SENT_COUNT As Integer = 14
    Const ST_NG_COUNT As Integer = 15, ST_LOGFILE As Integer = 16, ST_TEST_MAILTO As Integer = 17
    Const ST_EXCEL_SHEETNAME As Integer = 18, ST_COL_POS As Integer = 19, ST_MESSAGE_ID As Integer = 20
    Const ST_BCC_TO_HEADER As Integer = 21, ST_RSV1 As Integer = 22, ST_RSV2 As Integer = 23, ST_RSV3 As Integer = 24
    Const ST_END As Integer = 25
    Const MAX_BCC As Integer = 4000, STATUS_FILE As String = "\status.txt"

    Const STAT_IDLE As String = "設定中", STAT_STANDBY As String = "スタンバイ", STAT_SENDING As String = "送信中"
    Const STAT_SENT As String = "送信済み", STAT_ALL As String = "すべて"

    ' 封筒情報を格納するためのプロパティを定義
    Private Envelop_base As String
    Private _Name As String
    Private _Status As String
    Private _MailCount As String
    Private _PlanDate As String
    Private _SentDate As String
    Private _ReplyCount As String
    Private _LastModified As String

    ' 封筒名
    Public Property Name() As String
        Get
            Return Me._Name
        End Get
        Set(ByVal value As String)
            Me._Name = value
        End Set
    End Property

    ' ステータス
    Public Property Status() As String
        Get
            Return Me._Status
        End Get
        Set(ByVal value As String)
            Me._Status = value
        End Set
    End Property

    ' メール数
    Public Property MailCount() As String
        Get
            Return Me._MailCount
        End Get
        Set(ByVal value As String)
            Me._MailCount = value
        End Set
    End Property

    ' 送信予定日
    Public Property PlanDate() As String
        Get
            Return Me._PlanDate
        End Get
        Set(ByVal value As String)
            Me._PlanDate = value
        End Set
    End Property

    ' 送信完了日
    Public Property SentDate() As String
        Get
            Return Me._SentDate
        End Get
        Set(ByVal value As String)
            Me._SentDate = value
        End Set
    End Property

    ' リプライ数
    Public Property ReplyCount() As String
        Get
            Return Me._ReplyCount
        End Get
        Set(ByVal value As String)
            Me._ReplyCount = value
        End Set
    End Property
    ' 最終更新日付
    Public Property LastModified() As String
        Get
            Return Me._LastModified
        End Get
        Set(ByVal value As String)
            Me._LastModified = value
        End Set
    End Property

    ' 封筒情報一覧を取得するSELECTメソッド
    <DataObjectMethod(DataObjectMethodType.Select, True)> _
    Public Function GetEnvelop(ByVal Name As String, ByVal StatusName As String, _
         ByVal SortExpression As String, ByVal SortDirection As String) As List(Of Envelop)

        Dim list As New List(Of Envelop)()
        Envelop_base = Name
        Dim dir As New DirectoryInfo(Envelop_base)
        Dim dirs As Object = dir.GetDirectories()
        Dim status As String()
        Dim ok As Boolean
        Dim statusfile As String
        For Each fl As DirectoryInfo In dirs
            statusfile = Envelop_base & "\" & fl.Name & STATUS_FILE
            status = read_status(statusfile)
            If StatusName = "" Or StatusName = "すべて" Then
                ok = True
            Else
                ok = get_current_status(status) = StatusName
            End If
            If ok Then ' スタータスで絞込み
                Dim f As New Envelop
                f.Name = fl.Name
                f.Status = get_current_status(status)
                If f.Status = STAT_SENT Then ' 送信済み
                    If status(ST_SENT_COUNT) = "" Then status(ST_SENT_COUNT) = "0"
                    f.Status = f.Status & "(" & status(ST_SENT_COUNT) & ")"
                End If
                f.MailCount = status(ST_MAIL_COUNT)
                If f.MailCount = "" Then f.MailCount = 0
                f.PlanDate = status(ST_PLAN_DATETIME)
                f.SentDate = status(ST_END_DATETIME)
                f.ReplyCount = read_replycount(Envelop_base, f.Name)
                If f.ReplyCount = "" Then f.ReplyCount = 0
                f.LastModified = File.GetLastWriteTime(statusfile)
                list.Add(f)
            End If
        Next
        ' ソートして返す
        Return sort_envelop(list, SortExpression, SortDirection)
    End Function

    ' 指定された封筒フォルダを削除するためのDELETEメソッド
    <DataObjectMethod(DataObjectMethodType.Delete, True)> _
    Public Sub Delete(ByVal name As String)
        'Dim Server = HttpContext.Current.Server
        ' フォルダを削除
        Try
            Directory.Delete(name, True)
        Catch ex As IOException
            Throw New ApplicationException("フォルダ削除失敗 " & name & ex.Message)
        End Try

    End Sub

    ' 新しい封筒フォルダを作成Insertメソッド
    <DataObjectMethod(DataObjectMethodType.Insert, True)> _
    Public Sub Insert(ByVal name As String)
        Dim cFileInfo As New FileInfo(name)
        Dim envelopbase As String = cFileInfo.DirectoryName
        Dim newenvelop As String = Path.GetFileName(name)
        create_envelop(envelopbase, newenvelop)
    End Sub

    ' 封筒作成
    Sub create_envelop(ByVal envelopbox As String, ByVal newenvelop As String)
        Dim envelopname As String
        Dim statusfile As String
        envelopname = envelopbox & "\" & newenvelop
        Try
            Directory.CreateDirectory(envelopname)
            Directory.CreateDirectory(envelopname & "\mailbox")
        Catch
            Throw New ApplicationException("フォルダ作成に失敗 " & envelopname)

        End Try
        statusfile = envelopname & STATUS_FILE
        Try
            Dim sw As New StreamWriter(statusfile, False, System.Text.Encoding.GetEncoding("Shift_Jis"))
            Dim status(ST_END) As String
            ' 設定ファイルに既定値セット
            status(ST_SUBJECT) = newenvelop  ' 件名は封筒名
            status(ST_SERVER) = System.Configuration.ConfigurationManager.AppSettings("mail_server")
            status(ST_MAILFROM) = System.Configuration.ConfigurationManager.AppSettings("mail_from")
            status(ST_EXCEL_SHEETNAME) = System.Configuration.ConfigurationManager.AppSettings("excel_sheet")
            status(ST_COL_POS) = System.Configuration.ConfigurationManager.AppSettings("col_pos")
            status(ST_TEST_MAILTO) = System.Configuration.ConfigurationManager.AppSettings("test_mail")

            sw.Write(Join(status, Environment.NewLine))
            sw.Close()
        Catch
            Throw New ApplicationException("設定ファイルの書き込みに失敗 " & statusfile)
        End Try
    End Sub

    ' 封筒情報読込み
    Function read_status(ByVal statusfile As String) As String()
        Dim sr As StreamReader
        Try
            sr = New StreamReader(statusfile, System.Text.Encoding.Default)
        Catch ex As Exception
            Return Split(New String(Environment.NewLine, ST_END), Environment.NewLine)
        End Try
        Dim strBuffer As String
        strBuffer = sr.ReadToEnd()
        sr.Close()
        strBuffer = strBuffer.Replace(Environment.NewLine, vbCr) 'crlfを一旦crのみに変更
        Return strBuffer.Split(vbCr) ' しないと Environment.NewLine ではSplit に失敗
    End Function

    ' カレントステータス
    Function get_current_status(ByVal status As String()) As String
        If status(ST_PLAN_DATETIME) = "" Then ' 送信予定日時なし？
            Return STAT_IDLE
        ElseIf status(ST_END_DATETIME) <> "" Then ' 送信完了日時あり？
            Return STAT_SENT
        ElseIf status(ST_START_DATETIME) <> "" Then ' 送信開始日時あり？
            Return STAT_SENDING
        Else
            Return STAT_STANDBY
        End If
        Return ""
    End Function

    ' リプライメール数取得
    Function read_replycount(ByVal envelopbox As String, ByVal envelop As String) As String
        Dim dir As String
        dir = envelopbox & "\" & envelop & "\mailbox"
        Dim files As String() = Directory.GetFiles( _
                        dir, "*", SearchOption.AllDirectories)
        If Not IsArray(files) Then Return "0"
        Return files.Length
    End Function


    Const adInteger As Integer = 3, adDate As Integer = 7, adFldIsNullable As Integer = 32, adVarChar As Integer = 200
    ' ADOでソート  [参照の追加] Microsoft ActiveX Data Objects Recordset 6.0 Library
    Function sort_envelop(ByVal ar As List(Of Envelop), ByVal SortExpression As String, _
                          ByVal SortDirection As String) As List(Of Envelop)
        If ar.Count = 0 Then Return ar
        Dim SortDirectionCommand As String
        Dim list As New List(Of Envelop)()
        Dim r As ADOR.Recordset = New ADOR.Recordset
        If SortExpression = "" Then SortExpression = "Name"
        If SortDirection = "" Then SortDirection = "ASC"
        SortDirectionCommand = SortExpression & " " & SortDirection

        r.Fields.Append("Name", adVarChar, 128, adFldIsNullable)
        r.Fields.Append("Status", adVarChar, 128, adFldIsNullable)
        r.Fields.Append("MailCount", adInteger, , adFldIsNullable)
        r.Fields.Append("PlanDate", adDate, , adFldIsNullable)
        r.Fields.Append("SentDate", adDate, , adFldIsNullable)
        r.Fields.Append("ReplyCount", adInteger, , adFldIsNullable)
        r.Fields.Append("LastModified", adDate, , adFldIsNullable)
        r.Open()
        For Each items As Envelop In ar
            r.AddNew()
            r.Fields("Name").Value = items.Name
            r.Fields("Status").Value = items.Status
            r.Fields("MailCount").Value = Int(items.MailCount)
            If IsDate(items.PlanDate) Then
                r.Fields("PlanDate").Value = items.PlanDate
            End If
            If IsDate(items.SentDate) Then
                r.Fields("SentDate").Value = items.SentDate
            End If
            r.Fields("ReplyCount").Value = Int(items.ReplyCount)
            r.Fields("LastModified").Value = items.LastModified
            r.Update()
        Next
        r.Sort = SortDirectionCommand
        r.MoveFirst()
        Do Until r.EOF
            Dim f As New Envelop
            f.Name = r.Fields("Name").Value
            f.Status = r.Fields("Status").Value
            f.MailCount = r.Fields("MailCount").Value
            If Not IsDBNull(r.Fields("PlanDate").Value) Then
                f.PlanDate = format_date(r.Fields("PlanDate").Value)
            End If
            If Not IsDBNull(r.Fields("SentDate").Value) Then
                f.SentDate = format_date(r.Fields("SentDate").Value)
            End If
            f.ReplyCount = r.Fields("ReplyCount").Value
            f.LastModified = format_date(r.Fields("LastModified").Value)
            list.Add(f)
            r.MoveNext()
        Loop
        r.Close()
        r = Nothing
        sort_envelop = list
    End Function
    ' 日付変換 秒削除
    Function format_date(ByVal dtstr As String) As String
        Dim dt As DateTime = dtstr
        Return dt.ToString("yyyy/MM/dd HH:mm")
    End Function

End Class
