﻿
Imports System.Web.UI

Partial Class envelopmain
    Inherits System.Web.UI.Page
    Const STAT_IDLE As String = "設定中", STAT_STANDBY As String = "スタンバイ", STAT_SENDING As String = "送信中"
    Const STAT_SENT As String = "送信済み", STAT_ALL As String = "すべて"

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load


        If Not Page.IsPostBack Then
            ' 封筒ベースフォルダ名取得
            Dim envelop_base As String = System.Configuration.ConfigurationManager.AppSettings("envelop_base")
            ViewState("envelop_base") = envelop_base
            ods.SelectParameters("name").DefaultValue = envelop_base

            If Not Session("SortExpression") Is Nothing Then
                ods.SelectParameters("SortExpression").DefaultValue = Session("SortExpression")
                ods.SelectParameters("SortDirection").DefaultValue = Session("SortDirection")
            End If
            If Not Session("pagesize") Is Nothing Then
                GridView1.PageSize = Session("pagesize")
                DropDownListPageSize.SelectedValue = Session("pagesize")
            Else
                GridView1.PageSize = DropDownListPageSize.SelectedValue
                Session("pagesize") = GridView1.PageSize
            End If
            If Not Session("statusname") Is Nothing Then
                DropDownListStatus.SelectedValue = Session("statusname")
                ods.SelectParameters("statusname").DefaultValue = Session("statusname")
            End If
            If Not Session("pageindex") Is Nothing Then
                GridView1.PageIndex = Session("pageindex")
            End If
        Else
            GridView1.PageSize = DropDownListPageSize.SelectedValue
            Session("pagesize") = GridView1.PageSize
        End If
    End Sub


    Protected Sub ButtonAction_Click(sender As Object, e As EventArgs) Handles ButtonAction.Click
        Dim emsg As String

        If DropDownListAction.SelectedValue <> "delete" Then Exit Sub
        For i As Integer = 1 To GridView1.Rows.Count
            Dim checkrow As CheckBox = TryCast(GridView1.Rows(i - 1).FindControl("SelectCheckBox"), CheckBox)
            Dim lblname As Label = DirectCast(GridView1.Rows(i - 1).FindControl("lblname"), Label)
            If checkrow.Checked Then
                emsg = envelop_delete(lblname.Text)
                msg.Text = emsg
                Exit Sub
            End If
        Next
        msg.Text = ""
    End Sub

 
    ' ステータス絞込み
    Protected Sub DropDownListStatus_SelectedIndexChanged(sender As Object, e As EventArgs) Handles DropDownListStatus.SelectedIndexChanged
        Dim statusname As String = DropDownListStatus.SelectedValue
        ods.SelectParameters("statusname").DefaultValue = statusname
        Session("statusname") = statusname
    End Sub

    ' ソート順　フリップフロップ
    Private Function GetSortDirection(ByVal column As String) As String
        Dim sortDirection As String = "ASC"
        Dim sortExpression As String = TryCast(Session("SortExpression"), String)
        If sortExpression IsNot Nothing Then
            If sortExpression = column Then
                Dim lastDirection As String = TryCast(Session("SortDirection"), String)
                If lastDirection IsNot Nothing _
                  AndAlso lastDirection = "ASC" Then
                    sortDirection = "DESC"
                End If
            End If
        Else
            If column = "Name" Then sortDirection = "DESC"
        End If
        Session("SortDirection") = sortDirection
        Session("SortExpression") = column
        Return sortDirection
    End Function

    Protected Sub GridView1_PageIndexChanged(sender As Object, e As EventArgs) Handles GridView1.PageIndexChanged
        Session("pageindex") = GridView1.PageIndex
    End Sub

    Protected Sub GridView1_RowCommand(sender As Object, e As GridViewCommandEventArgs) Handles GridView1.RowCommand
        If (e.CommandName = "cancel") Then
            Dim envelop As String = e.CommandArgument
            Dim cancelfile As String = ViewState("envelop_base") & "\" & envelop & "\cancel.txt"
            Dim sjisEnc As Encoding = Encoding.GetEncoding("Shift_JIS")
            Dim writer As New System.IO.StreamWriter(cancelfile, True, sjisEnc)
            writer.WriteLine("キャンセル受付")
            writer.WriteLine(Now())
            writer.Close()
        End If
    End Sub


    Protected Sub GridView1_RowDataBound(sender As Object, e As GridViewRowEventArgs) Handles GridView1.RowDataBound
        If e.Row.RowType = DataControlRowType.DataRow Then
            ' スタータス色分け
            Dim cell As System.Web.UI.WebControls.TableCell = e.Row.Cells(2)
            Dim lblstatus As Label = e.Row.FindControl("lblstatus")
            Dim stat As String = lblstatus.Text
            Select Case stat
                Case STAT_STANDBY
                    cell.BackColor = Drawing.Color.Green
                    cell.ForeColor = Drawing.Color.White
                Case STAT_SENDING
                    cell.BackColor = Drawing.Color.Blue
                    cell.ForeColor = Drawing.Color.White
                    Dim btncancel As Button = e.Row.FindControl("buttoncancel")
                    btncancel.Visible = True
                Case STAT_SENT
                    cell.BackColor = Drawing.Color.MintCream
                    cell.ForeColor = Drawing.Color.Black
                Case Else
            End Select

            Dim envelopname As Label = e.Row.FindControl("lblname")
            Dim showmailLink As HyperLink = e.Row.FindControl("hyperLinkshowmail")
            If showmailLink.Text <> "0" Then
                showmailLink.NavigateUrl = "showmail.aspx?envelop=" & Server.UrlEncode(envelopname.Text)
            End If
            Dim editLink As HyperLink = e.Row.FindControl("hyperLinkedit")
            editLink.NavigateUrl = "envelopedit.aspx?envelop=" & Server.UrlEncode(envelopname.Text)

        End If


    End Sub

    ' ソートイベント
    Protected Sub GridView1_Sorting(sender As Object, e As GridViewSortEventArgs) Handles GridView1.Sorting
        e.Cancel = True ' 標準ソートオフ
 
        ods.SelectParameters("SortExpression").DefaultValue = e.SortExpression
        ods.SelectParameters("SortDirection").DefaultValue = GetSortDirection(e.SortExpression)
    End Sub


    ' ヘッダのCheckBoxで各列のCheckBoxを一斉にON/OFF
    Protected Sub AllCheckedChanged(sender As Object, e As EventArgs)
        Dim checkheader As CheckBox = TryCast(GridView1.HeaderRow.FindControl("SelectAll"), CheckBox)
        For i As Integer = 1 To GridView1.Rows.Count
            Dim checkrow As CheckBox = TryCast(GridView1.Rows(i - 1).FindControl("SelectCheckBox"), CheckBox)
            checkrow.Checked = checkheader.Checked
        Next
    End Sub

    Protected Sub addnew_Click(sender As Object, e As EventArgs) Handles addnew.Click
        Dim name As String = Trim(TextBoxEnvelop.Text)
        If Len(name) = 0 Then
            msg.Text = "封筒名を指定"
            Exit Sub
        End If
        msg.Text = ""
        Dim envelop_base As String = ViewState("envelop_base")
        ' フォルダ名チェック
        If InStr(name, "/") > 0 Or InStr(name, "\") > 0 Or _
           InStr(name, """") > 0 Or InStr(name, "'") > 0 Or _
           InStr(name, "|") > 0 Or InStr(name, "*") > 0 Or _
           InStr(name, " ") > 0 Or InStr(name, "　") > 0 Or _
           InStr(name, ";") > 0 Or InStr(name, ",") > 0 Then
            msg.Text = "封筒名に特殊文字が含まれてます " & name
            Exit Sub
        End If
        If System.IO.File.Exists(envelop_base & "\" & name) Then
            msg.Text = name + "'は存在します。"
            Exit Sub
        End If
        ods.InsertParameters("name").DefaultValue = envelop_base & "\" & name
        Try
            ods.Insert()
        Catch ex As ApplicationException
            msg.Text = ex.Message
        End Try
    End Sub

    Protected Function envelop_delete(ByVal envelop As String) As String
        Dim envelop_base As String = ViewState("envelop_base")
        ods.DeleteParameters("name").DefaultValue = envelop_base & "\" & envelop
        Try
            ods.Delete()
        Catch ex As ApplicationException
            Return ex.Message
        End Try
        Return ""
    End Function

End Class
